Only consider open subtasks when computing the priority of a parent issue

2010-07-14 16:00 - Norbert Bérci

Status: Closed Start date: 2010-07-14

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 3.3.0   

Resolution: Fixed Affected version:  

Description

When computing the priority of a task, only subtasks with not closed status should be considered.

see http://demo.redmine.org/issues/26174

Related issues:

Related to Redmine - Feature #5490: Option for independent subtask priority/s... Closed 2010-05-10

Related to Redmine - Defect #6847: Parent priorities not dropping when subtas... Closed 2010-11-08

Has duplicate Redmine - Feature #13736: Parent priority does not update when ... Closed

Has duplicate Redmine - Feature #19921: Issue priority with subtasks : not wi... Closed

Has duplicate Redmine - Feature #15289: Recalculate priority of a parent issu... Closed

Has duplicate Redmine - Defect #14933: Parent issues default to highest prior... Closed

Associated revisions

Revision 15064 - 2016-01-16 10:00 - Jean-Philippe Lang

Only consider open subtasks when computing the priority of a parent issue (#5880).

Patch by Go MAEDA.

History

#1 - 2010-07-15 15:15 - dimitar korudjiiski

- % Done changed from 0 to 60

Norbert Bérci wrote:

When computing the priority of a task, only subtasks with not closed status should be considered.

see http://demo.redmine.org/issues/26174

#2 - 2010-07-20 21:23 - Norbert Bérci

set back because previous modifier was using this instead of demo.redmine.org

#3 - 2010-07-20 21:23 - Norbert Bérci

- % Done changed from 60 to 0

#4 - 2010-11-08 08:21 - Ewan Makepeace

1. Agreed.

2. Also there is no way to tell which of many subtasks is driving the priority.

3. For example my top priority level is emergency - but when it is a group I cant tell which is the emergency subtask (which might actually be

closed!)

#5 - 2010-11-10 11:13 - Andreas Bosch

+1 - related to #5490 and #6847

Also see my forum post regarding this issue.
#6 - 2011-11-21 16:39 - Mischa The Evil

- Subject changed from parent task priority computation to Only consider open subtasks when computing the priority of a parent issue

#7 - 2011-11-21 16:40 - Mischa The Evil

- Category set to Issues

#8 - 2013-02-20 01:25 - Ross Saad

+1

#9 - 2013-02-20 04:09 - John Pisani

+1

#10 - 2013-04-18 22:19 - Emmanuel Serau

+1

#11 - 2013-10-25 21:31 - Mikołaj Milej

+10

but, show me the code, I'll create a patch for it (or I'll find the code).

edit:

works for me:

in file: app/models/issue.rb

changed

      # priority = highest priority of children

      if priority_position = p.children.maximum("#{IssuePriority.table_name}.position", :joins => :priority)

        p.priority = IssuePriority.find_by_position(priority_position)

      end

to

      # priority = highest priority of children

      if p.children.count > 0

        if priority_position = p.children.maximum("#{IssuePriority.table_name}.position", {:joins => [

:priority, :status], :conditions => 'is_closed = 0'})

        else

          priority_position = IssuePriority.where("#{IssuePriority.table_name}.position", :conditions => 

'is_default = 1')

        end

        p.priority = IssuePriority.find_by_position(priority_position)

      end

 I know almost nothing about Ruby and RoR so there is place for improvements and bug fixes ;]

#12 - 2014-09-12 01:23 - A B

The above patch does not work on db's with proper boolean types such as PostgreSQL; it also has a bug in the else  clause in that it returns an

IssuePriority object rather than a number. Here's an updated version that should work on all db's and fixes the bug:

      # priority = highest priority of open children

      if p.children.count > 0

        if priority_position = p.children.maximum("#{IssuePriority.table_name}.position", {:joins => [

:priority, :status], :conditions => ['is_closed = ?', false]})

        else

          priority_position = IssuePriority.where(is_default: true).pluck(:position).first

        end

        p.priority = IssuePriority.find_by_position(priority_position)

      end

#13 - 2014-12-09 12:05 - txemi M

+1

I would like to see this implemented.

It is difficult for me get useful task views based on priority with all those already not important parent tasks showing on top.
#14 - 2016-01-11 08:49 - Go MAEDA

- Has duplicate Feature #19921: Issue priority with subtasks : not with closed issues added

#15 - 2016-01-11 08:51 - Go MAEDA

- Target version set to Candidate for next major release

#16 - 2016-01-11 09:07 - Go MAEDA

- Has duplicate Feature #15289: Recalculate priority of a parent issue automatically after child issue is closed added

#17 - 2016-01-11 09:09 - Go MAEDA

- Has duplicate Defect #14933: Parent issues default to highest priority child issue, should be highest priority *OPEN* child issue added

#18 - 2016-01-11 09:48 - Go MAEDA

This is a patch for current trunk (r15058).

Index: app/models/issue.rb

===================================================================

--- app/models/issue.rb    (revision 15058)

+++ app/models/issue.rb    (working copy)

@@ -1451,9 +1451,11 @@

   def recalculate_attributes_for(issue_id)

     if issue_id && p = Issue.find_by_id(issue_id)

       if p.priority_derived?

-        # priority = highest priority of children

-        if priority_position = p.children.joins(:priority).maximum("#{IssuePriority.table_name}.position")

+        # priority = highest priority of open children

+        if priority_position = p.children.open.joins(:priority).maximum("#{IssuePriority.table_name}.position

")

           p.priority = IssuePriority.find_by_position(priority_position)

+        else

+          p.priority = IssuePriority.default

         end

       end

#19 - 2016-01-14 14:40 - Go MAEDA

- File defect-5880.diff added

- Target version changed from Candidate for next major release to 3.3.0

Here is a patch with tests: defect-5880.diff

Please consider merging this fix.

#20 - 2016-01-16 10:00 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Patch committed, thanks.

Files

defect-5880.diff 2.32 KB 2016-01-14 Go MAEDA
